var app = angular.module('TaskerHelp', []);

app.controller('HelpController', function ($scope, $location, $sce) {
    var _this = this;
    _this.Version = "8.0";
    _this.order = 'Title';
    _this.search = {};


    _this.GetWebSafe = function (string) {
        // remove '...'
        var webSafe = string.replace('...', '');
        // replace non web safe characters with underscores
        var search = /[ @\.\/\-:]/;
        var replacement = '_';
        webSafe = webSafe.replace(new RegExp(search, 'g'), replacement);
        var search = />/;
        var replacement = '-';
        webSafe = webSafe.replace(new RegExp(search, 'g'), replacement);
        // replace multiple underscores with one underscore
        webSafe = webSafe.replace(new RegExp(/_+/, 'g'), '_');
        // we wont lowercase
        webSafe = webSafe.toLowerCase();
        return webSafe;
    };


    _this.trustAsHtml = function (string) {
        return $sce.trustAsHtml(string);
    };


    _this.Topics = [
        { Title: "Introduction", Source: "introduction.html" },
        {
            Title: "Main Menu", Source: "main-menu.html", Topics: [
                {
                    Title: "File Menu", Source: "file-menu.html", Topics: [
                        { Title: "File > New" },
                        { Title: "File > Open" },
                        { Title: "File > Save" },
                        { Title: "File > Save As..." },
                        { Title: "File > Clone..." },
                        { Title: "File > Rename..." },
                        { Title: "File > Edit Notes..." },
                        { Title: "File > Close" },
                        { Title: "File > Revert" },
                        { Title: "File > Restore" },
                        { Title: "File > Enable / Disable" },
                        { Title: "File > Delete" },
                        { Title: "File > Preferences" },
                        { Title: "File > Upload" },
                        { Title: "File > Download" }
                    ]
                },
                {
                    Title: "Tools Menu", Source: "tools-menu.html", Topics: [
                        { Title: "Tools > Web UI - JNIOR Configuration" },
                        { Title: "Tools > Grapher" },
                        { Title: "Tools > Grapher Configuration" }
                    ]
                },
                {
                    Title: "Help Menu", Source: "help-menu.html", Topics: [
                        { Title: "Help > Help" },
                        { Title: "Help > Knowledgebase" },
                        { Title: "Help > Contact Us" },
                        { Title: "Help > Tasker Application @ Jnior.com" },
                        { Title: "Help > Release Notes" },
                        { Title: "Help > Show Log" }
                    ]
                }
            ]
        },
        { Title: "Status Bar", Source: "status-bar.html" },
        {
            Title: "Workspaces View", Source: "workspaces.html", Topics: [
                { Title: "Create a Workspace" },
                { Title: "Uploading a Workspace" },
                { Title: "Downloading a Workspace" },
                { Title: "Cloning a Workspace" },
                { Title: "Removing a Workspace" },
                { Title: "Enabling / Disabling a Workspace" },
                { Title: "Renaming a Workspace" },
                { Title: "Editing Notes for a Workspace" },
                { Title: "Open a Workspace" }
            ]
        },
        {
            Title: "Active Workspace View", Source: "active-workspace.html", Topics: [
                { Title: "Workspaces Pane", Source: "workspaces-pane.html" },
                {
                    Title: "Tasks Tab", Source: "tasks-tab.html", Topics: [
                        { Title: "Adding a Task" },
                        { Title: "Removing a Task" },
                        { Title: "Reordering a Task" },
                        { Title: "Cloning a Task" },
                        { Title: "Executing a Task" },
                        { Title: "Renaming a Task" },
                        { Title: "Selecting a Task" },
                        { Title: "Adding an Action" },
                        { Title: "Removing an Action" },
                        { Title: "Reordering an Action" },
                        { Title: "Cloning an Action"}
                    ]
                },
                {
                    Title: "Devices Tab", Source: "devices-tab.html", Topics: [
                        { Title: "Adding a Device" },
                        { Title: "Removing a Device" },
                        { Title: "Reordering a Device" },
                        { Title: "Renaming a Device" },
                        {
                            Title: "Device Types", Source: "device-types.html", Topics: [
                                { Title: "Ethernet Device" },
                                { Title: "SNMP Device" }
                            ]
                        }
                    ]
                },
                {
                    Title: "Loggers Tab", Source: "loggers-tab.html", Topics: [
                        { Title: "Adding a Logger" },
                        { Title: "Removing a Logger" },
                        { Title: "Reordering a Logger" },
                        { Title: "Renaming a Logger" },
                        { Title: "Entering a File Name" },
                        { Title: "Entering a Header" },
                        { Title: "Entering a Timestamp" },
                        { Title: "Entering Log Values" }
                    ]
                },
                {
                    Title: "Signals Tab", Source: "signals-tab.html", Topics: [
                        { Title: "Adding a Signal" },
                        { Title: "Removing a Signal" },
                        { Title: "Reordering a Signal" },
                        { Title: "Renaming a Signal" },
                        {
                            Title: "Signal Types", Source: "signal-types.html", Topics: [
                                { Title: "Digital Inputs" },
                                { Title: "Relay Outputs" },
                                { Title: "Temperature Probe" },
                                { Title: "Environmental Sensor" },
                                { Title: "4-20ma Inputs" },
                                { Title: "4-20ma Outputs" },
                                { Title: "10volt Inputs" },
                                { Title: "10volt Outputs" },
                            ]
                        }
                    ]
                },
                {
                    Title: "Triggers Tab", Source: "triggers-tab.html", Topics: [
                        { Title: "Adding a Trigger" },
                        { Title: "Removing a Trigger" },
                        { Title: "Reordering a Trigger" },
                        { Title: "Renaming a Trigger" },
                        {
                            Title: "Trigger Types", Source: "trigger-types.html", Topics: [
                                { Title: "Discrete Trigger" },
                                { Title: "Continuous Trigger" },
                                { Title: "Single Control Panel Switch Trigger" },
                                { Title: "Multiple Control Panel Switch Trigger" }
                            ]
                        }
                    ]
                },
                {
                    Title: "Schedules Tab", Source: "schedules-tab.html", Topics: [
                        { Title: "Adding a Schedule" },
                        { Title: "Removing a Schedule" },
                        { Title: "Reordering a Schedule" },
                        { Title: "Renaming a Schedule" },
                        { Title: "Enable/Disable a Schedule" },
                        { Title: "Adding a Rule" },
                        {
                            Title: "Rule Types", Source: "rule-types.html", Topics: [
                                { Title: "On Boot" },
                                { Title: "Sunrise" },
                                { Title: "Sunset" },
                                { Title: "Schedule" }
                            ]
                        }
                    ]
                }
            ]
        },
        {
            Title: "Task Actions", Source: "task-actions.html", Topics: [
                {
                    Title: "Relay Output Actions", Source: "relayoutput-actions.html", Topics: [
                        {
                            Title: "Close Relay", Source: "relayoutputs-closerelay.html", Arguments: [
                                { Name: "Channel", Type: "Number or String", Notes: "A <b>number</b> is used to specify the channel.  A <b>string</b> can be used to specify a variable or signal name." },
                            ]
                        },
                        { Title: "Open Relay", Source: "relayoutputs-openrelay.html" },
                        { Title: "Set Relay State", Source: "relayoutputs-setrelay.html" },
                        { Title: "Set Relays", Source: "relayoutputs-setrelays.html" },
                        { Title: "Pulse Relay", Source: "relayoutputs-pulserelay.html" },
                        { Title: "Pulse Relays", Source: "relayoutputs-pulserelays.html" },
                        { Title: "Reset Output Usage Meter", Source: "relayoutputs-resetoutputusagemeter.html" }
                    ]
                },
                {
                    Title: "Digital Input Actions", Source: "digitalinput-actions.html", Topics: [
                        { Title: "Set Conditioning State", Source: "digitalinputs-setconditioningstate.html" },
                        { Title: "Soft Invert Input", Source: "digitalinputs-softinputinvert.html" },
                        { Title: "Set Input Counter", Source: "digitalinputs-setinputcounter.html" },
                        { Title: "Reset Input Usage Meter", Source: "digitalinputs-resetinputusagemeter.html" },
                        { Title: "Clear Input Latch", Source: "digitalinputs-clearinputlatch.html" },
                        { Title: "Soft Pulse Input", Source: "digitalinputs-softpulseinput.html" }
                    ]
                },
                {
                    Title: "Analog Output Actions", Source: "analogoutput-actions.html", Topics: [
                        { Title: "Set 10v Percentage", Source: "analogoutputs-set10vpercentage.html" },
                        { Title: "Set 10v Voltage", Source: "analogoutputs-set10vvoltage.html" },
                        { Title: "Set 4-20ma Percentage", Source: "analogoutputs-set420mapercentage.html" },
                        { Title: "Set 4-20ma Amps", Source: "analogoutputs-set420maamps.html" }
                    ]
                },
                {
                    Title: "Control Panel Actions", Source: "controlpanel-actions.html", Topics: [
                        { Title: "Set LED", Source: "controlpanel-setled.html" },
                        { Title: "Play Alarm", Source: "controlpanel-playalarm.html" },
                        { Title: "Silence Alarm", Source: "controlpanel-silencealarm.html" }
                    ]
                },
                {
                    Title: "Control Structure Actions", Source: "controlstructure-actions.html", Topics: [
                        { Title: "If Block", Source: "controlstructures-ifblock.html" },
                        { Title: "If:Else Block", Source: "controlstructures-ifelseblock.html" },
                        { Title: "For Loop", Source: "controlstructures-loop.html" },
                        { Title: "While Loop", Source: "controlstructures-whileloop.html" }
                    ]
                },
                {
                    Title: "File Actions", Source: "file-actions.html", Topics: [
                        { Title: "File Delete", Source: "file-deletefile.html" },
                        { Title: "File Prepend", Source: "file-prependfile.html" },
                        {
                            Title: "File Copy", Source: "file-copyfile.html", Arguments: [
                                { Name: "File Name", Type: "Text" },
                                { Name: "File Destination", Type: "Text" },
                            ]
                        },
                        {
                            Title: "File Move", Source: "file-movefile.html", Arguments: [
                                { Name: "File Name", Type: "Text", Notes: "The source file path of the file to move" },
                                { Name: "File Destination", Type: "Text", Notes: "The destination file path" },
                            ]
                        },
                        { Title: "Log Entry", Source: "logging-logentry.html" },
                        { Title: "Log Profile", Source: "logging-logprofile.html" }
                    ]
                },
                {
                    Title: "Timing Actions", Source: "timing-actions.html", Topics: [
                        { Title: "At (Not Yet Implemented)", Source: "not-yet-implemented.html" },
                        { Title: "Sleep", Source: "timing-sleep.html" }
                    ]
                },
                {
                    Title: "Lighting Actions", Source: "lighting-actions.html", Topics: [
                        { Title: "Set LED Channel", Source: "lighting-setdimmerchannel.html" },
                        { Title: "Set LED RGB", Source: "lighting-setdimmerrgb.html" },
                        { Title: "Fade LED Channel", Source: "lighting-fadedimmerchannel.html" },
                        { Title: "Fade LED RGB", Source: "lighting-fadedimmerrgb.html" }
                    ]
                },
                {
                    Title: "Communication Actions", Source: "communication-actions.html", Topics: [
                        { Title: "TCP Send", Source: "communication-tcpsend.html" },
                        { Title: "TCP Receive", Source: "communication-tcpreceive.html" },
                        { Title: "TCP Close", Source: "communication-tcpclose.html" },
                        { Title: "HTTP Request", Source: "communication-httprequest.html" },
                        { Title: "HTTP Post", Source: "communication-httppost.html" },
                        { Title: "Email Send", Source: "communication-emailsend.html" },
                        { Title: "Email Profile", Source: "communication-emailprofilesend.html" },
                        { Title: "MQTT Publish", Source: "communication-mqttpublish.html" },
                        { Title: "SNMP Trap", Source: "communication-snmptrap.html" },
                        { Title: "SNMP Set", Source: "communication-snmpset.html" },
                        { Title: "Serial Send", Source: "communication-serialsend.html" }
                    ]
                },
                {
                    Title: "Other Actions", Source: "other-actions.html", Topics: [
                        { Title: "Comment", Source: "other-comment.html" },
                        { Title: "Command Line", Source: "other-commandline.html" },
                        { Title: "Reboot", Source: "other-reboot.html" },
                        { Title: "Execute Task", Source: "other-executetask.html" },
                        { Title: "Cancel Task", Source: "other-canceltask.html" },
                        { Title: "Execute Script", Source: "other-executescript.html" },
                        { Title: "User Alert", Source: "other-useralert.html" },
                        { Title: "Registry Write", Source: "other-registrywrite.html" },
                        { Title: "Set Variable", Source: "other-setvariable.html" }
                    ]
                }
            ]
        },
        {
            Title: "Value Syntax", Source: "value-syntax.html", Topics: [
                { Title: "Internal I/O" },
                { Title: "Temperature Probe I/O" },
                { Title: "Environmental Sensor I/O" },
                { Title: "Validate Days of Week" },
                { Title: "Validate Time of Day" },
                { Title: "4-20ma I/O" },
                { Title: "10volt I/O" },
                { Title: "Control Panel" }
            ]
        },
        {
            Title: "Logical Expressions", Source: "logical-expressions.html", Topics:
                [
                    { Title: "Simple Expressions" },
                    { Title: "Complex Expressions" },
                ]
        },
        {
            Title: "Sending Commands to Tasker", Source: "sending-commands-to-tasker.html", Topics:
                [
                    { Title: "ASCII TCP" },
                    { Title: "WebSockets" },
                    { Title: "Rest API" },
                ]
        },
        { Title: "Troubleshooting", Source: "troubleshooting.html" }
    ];


    _this.ActiveTopic = _this.Topics[0];



    // watch for changes to our $location.url() object.
    $scope.$watch(function () {
        return $location.url();
    }, function (url) {
        if (url) {
            var locationSearch = $location.search();
            _this.BlockId = locationSearch.blockId;
            if (_this.BlockId) {
                scrollTo('#' + _this.BlockId);
            }
        }
    });



    _this.setTopic = function (id) {
        var blockId = _this.GetWebSafe(id);
        $location.search('blockId', blockId);
    };



    _this.showBlock = function (blockId) {
        return !_this.BlockId || blockId == _this.BlockId;
    };


    _this.setOrder = function (order) {
        _this.order = order;
    };



    _this.getHtml = function (block) {
        return block.Id + '.html';
    };



    _this.scrollTo = function (block) {
        $location.search('blockId', block.Id);
    };


    _this.Blocks = [
        {
            Id: "value-syntax", Title: "Value Syntax", Category: "Syntax", Since: "3.0",
        },
        {
            Id: "action-examples", Title: "Task Examples", Category: "Examples", Since: "3.0",
        },
        {
            Id: "logging-examples", Title: "Logger Examples", Category: "Examples", Since: "3.0",
        },
        {
            Id: "other-comment", Title: "Comment", Category: "Other Actions", Since: "3.0", Arguments: [
                { Name: "Description", Type: "Text" },
            ]
        },
        {
            Id: "other-commandline", Title: "Command Line", Category: "Other Actions", Since: "3.0", Arguments: [
                { Name: "Command", Type: "Text" },
            ]
        },
        {
            Id: "other-reboot", Title: "Reboot", Category: "Other Actions", Since: "3.0", Arguments: [
            ]
        },
        {
            Id: "other-executetask", Title: "Execute Task", Category: "Other Actions", Since: "3.0", Arguments: [
                { Name: "Task", Type: "Text" },
            ]
        },
        {
            Id: "other-canceltask", Title: "Cancel Task", Category: "Other Actions", Since: "4.1", Arguments: [
                { Name: "Task Name", Type: "Text" },
            ]
        },
        {
            Id: "other-executescript", Title: "Execute Script Task", Category: "Other Actions", Since: "3.3", Arguments: [
                { Name: "Script Box", Type: "Text" },
            ]
        },
        {
            Id: "other-useralert", Title: "User Alert", Category: "Other Actions", Since: "3.5", Arguments: [
                { Name: "User Alert", Type: "Text" },
            ]
        },
        {
            Id: "other-deletefile", Title: "Delete File", Category: "Other Actions", Since: "3.3", Arguments: [
                { Name: "File Name", Type: "Text" },
            ]
        },
        {
            Id: "other-prependfile", Title: "Prepend File", Category: "Other Actions", Since: "3.3", Arguments: [
                { Name: "File Name", Type: "Text" },
                { Name: "Added Text", Type: "Text" },
            ]
        },
        {
            Id: "other-copyfile", Title: "Copy File", Category: "Other Actions", Since: "3.3", Arguments: [
                { Name: "File Name", Type: "Text" },
                { Name: "File Destination", Type: "Text" },
            ]
        },
        {
            Id: "other-movefile", Title: "Move File", Category: "Other Actions", Since: "3.3", Arguments: [
                { Name: "File Name", Type: "Text" },
                { Name: "File Destination", Type: "Text" },
            ]
        },
        {
            Id: "timing-sleep", Title: "Sleep", Category: "Timing Actions", Since: "3.0", Arguments: [
                { Name: "Duration", Type: "Number Block" },
            ]
        },
        {
            Id: "relayinputs-softinputinvert", Title: "Soft Input Invert", Category: "Input Actions", Since: "3.2", Arguments: [
                { Name: "Channel", Type: "Number Block" },
            ]
        },
        {
            Id: "relayinputs-setinputcounter", Title: "Set Input Counter", Category: "Input Actions", Since: "3.2", Arguments: [
                { Name: "Channel", Type: "Number Block" },
            ]
        },
        {
            Id: "relayinputs-resetinputusagemeter", Title: "Reset Input Usage Meter", Category: "Input Actions", Since: "3.2", Arguments: [
                { Name: "Channel", Type: "Number Block" },
            ]
        },
        {
            Id: "relayoutputs-closerelay", Title: "Close Relay", Category: "Output Actions", Since: "3.0", Arguments: [
                { Name: "Channel", Type: "Number Block" },
            ]
        },
        {
            Id: "relayoutputs-openrelay", Title: "Open Relay", Category: "Output Actions", Since: "3.0", Arguments: [
                { Name: "Channel", Type: "Number Block" },
            ]
        },
        {
            Id: "relayoutputs-setrelay", Title: "Set Relay State", Category: "Output Actions", Since: "3.0", Arguments: [
                { Name: "Channel", Type: "Number Block" },
                { Name: "State", Type: "HIGH or LOW" },
            ]
        },
        {
            Id: "relayoutputs-pulserelay", Title: "Pulse Relay", Category: "Output Actions", Since: "3.0", Arguments: [
                { Name: "Channel", Type: "Number Block" },
                { Name: "Duration", Type: "Seconds, can use decimals" }
            ]
        },
        {
            Id: "relayoutputs-setrelays", Title: "Set Relay States", Category: "Output Actions", Since: "3.0", Arguments: [
                { Name: "Channels", Type: "Number Block" },
                { Name: "States", Type: "Number Block" },
            ]
        },
        {
            Id: "relayoutputs-pulserelays", Title: "Pulse Relay States", Category: "Output Actions", Since: "3.0", Arguments: [
                { Name: "Channel", Type: "Number Block" },
                { Name: "States", Type: "Number Block" },
                { Name: "Duration", Type: "Seconds, can use decimals" }
            ]
        },
        {
            Id: "analogoutputs-set10vpercentage", Title: "Set 10v Percentage", Category: "Analog Output Actions", Since: "3.0", Arguments: [
                { Name: "Channel", Type: "Number Block" },
                { Name: "Percentage", Type: "Number Block" },
            ]
        },
        {
            Id: "analogoutputs-set10vvoltage", Title: "Set 10v Voltage", Category: "Analog Output Actions", Since: "3.0", Arguments: [
                { Name: "Channel", Type: "Number Block" },
                { Name: "Voltage", Type: "Number Block, can use decimals" },
            ]
        },
        {
            Id: "analogoutputs-set420mapercentage", Title: "Set 4-20ma Percentage", Category: "Analog Output Actions", Since: "3.0", Arguments: [
                { Name: "Channel", Type: "Number Block" },
                { Name: "Percentage", Type: "Number Block" },
            ]
        },
        {
            Id: "analogoutputs-set420maamps", Title: "Set 4-20ma Amps", Category: "Analog Output Actions", Since: "3.0", Arguments: [
                { Name: "Channel", Type: "Number Block" },
                { Name: "Amps", Type: "Number Block, can use decimals" },
            ]
        },
        {
            Id: "controlstructures-ifblock", Title: "If Block", Category: "Control Structure Actions", Since: "3.0", Arguments: [
                { Name: "If Variable", Type: "Text" },
            ]
        },
        {
            Id: "controlstructures-ifelseblock", Title: "If Else Block", Category: "Control Structure Actions", Since: "3.1", Arguments: [
                { Name: "If Variable", Type: "Text" },
            ]
        },
        {
            Id: "controlstructures-loop", Title: "Loop", Category: "Control Structure Actions", Since: "3.0", Arguments: [
                { Name: "Loop Variable", Type: "Text" },
                { Name: "Start Value of Length", Type: "Number Block" },
                { Name: "End Value of Length", Type: "Number Block" },
            ]
        },
        {
            Id: "controlstructures-whileloop", Title: "While Loop", Category: "Control Structure Actions", Since: "3.1", Arguments: [
                { Name: "Loop Variable", Type: "Text" },
            ]
        },
        {
            Id: "controlstructures-setvariable", Title: "Set Variable", Category: "Control Structure Actions", Since: "3.1", Arguments: [
                { Name: "Variable", Type: "Text" },
                { Name: "Value", Type: "Text" },
            ]
        },
        {
            Id: "controlpanel-setled", Title: "Set LED", Category: "Control Panel Actions", Since: "3.0", Arguments: [
                { Name: "Channel", Type: "Number Block" },
                { Name: "LED State", Type: "Drop-Down option" },
            ]
        },
        {
            Id: "controlpanel-playalarm", Title: "Play Alarm", Category: "Control Panel Actions", Since: "3.0", Arguments: [
                { Name: "Alarm Rate", Type: "Drop-Down option" },
                { Name: "Duration", Type: "Seconds, can use decimals" },
                { Name: "Volume Percentage", Type: "Number Block" },
            ]
        },
        {
            Id: "controlpanel-silencealarm", Title: "Silence Alarm", Category: "Control Panel Actions", Since: "3.0", Arguments: [
            ]
        },
        {
            Id: "lighting-setdimmerchannel", Title: "Set LED Dimmer Channel", Category: "Lighting Actions", Since: "3.0", Arguments: [
                { Name: "Channel", Type: "Number Block" },
                { Name: "Percentage", Type: "Number Block" },
            ]
        },
        {
            Id: "lighting-setdimmerrgb", Title: "Set LED Dimmer RGB", Category: "Lighting Actions", Since: "3.0", Arguments: [
                { Name: "Dimmer being set", Type: "Number Block" },
                { Name: "Red Percentage", Type: "Number Block" },
                { Name: "Green Percentage", Type: "Number Block" },
                { Name: "Blue Percentage", Type: "Number Block" },
            ]
        },
        {
            Id: "lighting-fadedimmerchannel", Title: "Fade LED Dimmer Channel", Category: "Lighting Actions", Since: "3.0", Arguments: [
                { Name: "Channel", Type: "Number Block" },
                { Name: "Percentage", Type: "Number Block" },
                { Name: "Duration", Type: "Seconds, can use decimals" },
            ]
        },
        {
            Id: "lighting-fadedimmerrgb", Title: "Fade LED Dimmer RGB", Category: "Lighting Actions", Since: "3.0", Arguments: [
                { Name: "Dimmer being set", Type: "Number Block" },
                { Name: "Red Percentage", Type: "Number Block" },
                { Name: "Green Percentage", Type: "Number Block" },
                { Name: "Blue Percentage", Type: "Number Block" },
                { Name: "Duration", Type: "Seconds, can use decimals" },
            ]
        },
        {
            Id: "logging-logentry", Title: "Log Entry", Category: "Logging Actions", Since: "3.0", Arguments: [
                { Name: "Text to be Logged", Type: "Text" },
                { Name: "File Path", Type: "Text" },
            ]
        },
        {
            Id: "logging-logprofile", Title: "Log Profile", Category: "Logging Actions", Since: "3.0", Arguments: [
                { Name: "Log Profile being called", Type: "Text" },
            ]
        },
        {
            Id: "network-tcpsend", Title: "Tcp Send", Category: "Network Actions", Since: "3.0", Arguments: [
                { Name: "Device", Type: "Drop-Down Select" },
                { Name: "Info being sent", Type: "Text" },
            ]
        },
        {
            Id: "network-tcpreceive", Title: "Tcp Receive", Category: "Network Actions", Since: "3.3", Arguments: [
                { Name: "Device", Type: "Drop-Down Select" },
                { Name: "Info being sent", Type: "Text" },
            ]
        },
        {
            Id: "network-tcpclose", Title: "Tcp Close", Category: "Network Actions", Since: "3.3", Arguments: [
                { Name: "Device", Type: "Drop-Down Select" },
                { Name: "Info being sent", Type: "Text" },
            ]
        },
        {
            Id: "network-emailsend", Title: "Email Send", Category: "Network Actions", Since: "3.0", Arguments: [
                { Name: "Recipient Email", Type: "Text" },
                { Name: "Email's Subject", Type: "Text" },
                { Name: "Email's Attachment", Type: "Text" },
                { Name: "Email's Message", Type: "Text" },
            ]
        },
        {
            Id: "network-emailprofilesend", Title: "Email Profile Send", Category: "Network Actions", Since: "3.0", Arguments: [
                { Name: "Email Profile", Type: "Text" },
            ]
        },
        {
            Id: "network-snmptrap", Title: "SNMP Trap", Category: "Network Actions", Since: "3.1", Arguments: [
                { Name: "OID", Type: "Number Block" },
                { Name: "Data", Type: "Text" },
                { Name: "Device", Type: "Drop-Down Select" },
            ]
        },
        {
            Id: "network-snmpset", Title: "SNMP Set", Category: "Network Actions", Since: "4.1", Arguments: [
                { Name: "OID", Type: "Number Block" },
                { Name: "Data", Type: "Text" },
                { Name: "Value", Type: "Drop-Down Select" },
                { Name: "Device", Type: "Drop-Down Select" }
            ]
        },
        {
            Id: "network-httprequest", Title: "HTTP Request", Category: "Network Actions", Since: "5.0", Arguments: [
                { Name: "URL Address", Type: "Text" },
            ]
        },
        {
            Id: "network-httppost", Title: "HTTP Post", Category: "Network Actions", Since: "3.8", Arguments: [
                { Name: "URL Address", Type: "Text" },
                { Name: "Data", Type: "Text" }
            ]
        },
    ];

    _this.getCategories = function () {
        return ['Task Actions'];
    };

});



app.directive('toc', function ($compile) {
    return {
        restrict: 'A', // attribute
        scope: {
            topics: '=',
            controller: '='
        },
        link: function ($scope, element, attrs) {
            var template = $scope.topics ? '<li ng-repeat="topic in topics" style="padding-left: 32px;">' +
                '<a href="javascript: void(0);" ng-click="controller.setTopic(topic.Title)"' +
                ' ng-style="{color: topic.Source == \'blank.html\' ? \'rgb(189, 54, 47)\' : \'\'}">{{topic.Title}}</a>' +
                //'<a href="{{topic.Title}}"' +
                //' ng-style="{color: topic.Source == \'blank.html\' ? \'rgb(189, 54, 47)\' : \'\'}">{{topic.Title}}</a>' +
                '<ol toc topics="topic.Topics" controller="controller"></ol>' +
                '</li>' : '';
            element.html(template).show();
            $compile(element.contents())($scope);
        }
    };
});



app.directive('content', function ($compile) {
    return {
        restrict: 'A', // attribute
        scope: {
            topics: '=',
            controller: '=',
            level: '='
        },
        link: function ($scope, element, attrs) {
            var template = $scope.topics ? '<li ng-repeat="topic in topics"' +
                (1 == $scope.level ? ' style="page-break-after: always; page-break-inside: avoid;"' : ' ng-style="{\'page-break-inside\': (undefined == topic.Topics ? \'avoid\' : \'\')}"') + '>' +
                '<h' + $scope.level + ' ng-if="null != topic.Source" id="{{controller.GetWebSafe(topic.Title)}}">' +
                '<span ng-bind="topic.Title"></span>' +
                '<a href="{{controller.GetWebSafe(topic.Title)}}"><i class="fa fa-anchor" aria-hidden="true" style="margin-left: 12px; font-size: 14pt;"></i></a>' +
                '</h' + $scope.level + '>' +
                '<div ng-if="null != topic.Source" class="blockdef" style="padding-left: 32px;">' +
                '  <div ng-include="\'/tasker/help/\' + topic.Source"></div>' +
                // '  <div ng-bind-html="controller.trustAsHtml(topic.HTML)" style="padding: 12px 0;"></div>' +
                '  <table ng-show="topic.Arguments !== nothing" class="table table-striped table-condensed">' +
                '  <tr>' +
                '      <th>Element</th>' +
                '      <th>Type</th>' +
                '      <th>Notes</th>' +
                '  </tr>' +
                '  <tr ng-repeat="argument in topic.Arguments">' +
                '      <td ng-bind="argument.Name"></td>' +
                '      <td ng-bind="argument.Type"></td>' +
                '      <td ng-bind-html="controller.trustAsHtml(argument.Notes)"></td>' +
                '  </tr>' +
                '  </table>' +
                '</div>' +
                '<ol ng-if="null != topic.Topics" content topics="topic.Topics" controller="controller" level="' +
                ($scope.level + 1) + '" style="padding-left: 32px;"></ol>' +
                '</li>' : '';
            element.html(template).show();
            $compile(element.contents())($scope);
        }
    };
});



var total = 0;
var fetched = 0;


app.run(function ($rootScope) {
    $rootScope.$on("$includeContentRequested", function (event, templateName) {
        total++;
        console.log('requested ' + templateName + ': ' + total);
    });
});



app.run(function ($rootScope) {
    $rootScope.$on("$includeContentLoaded", function (event, templateName) {
        fetched++;
        console.log('fetched ' + templateName + ': ' + fetched);
        var percentComplete = Math.floor(fetched / total * 100);
        $('#loading-percentage').text(percentComplete);
        if (fetched == total) {
            setTimeout(function () {
                ready();
                $('#loading').hide();
                scrollTo(selectedElementId);
            }, 500);
        }
    });
});